/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC18F24K40
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

#include "mcc_generated_files/mcc.h"

#include <htc.h>



unsigned int sec;

#define	DISPCLK			RA0
#define	DISPDATA		RA1
#define	STROBE			RA2
#define	DEC				RA3
#define	INC				RA4
#define SENSR_SLCT		RA5
#define	OUTEN			RA7

#define PRG_EN			RC1
#define CALIBR			RC2						//Calibration for PT100
#define	RLY1			RC6
#define LEDSEL			RC5
#define	SCL				RC3  
#define	SDA				RC4  


#define MCP3421ADDR	0xD0


unsigned int count=0;
//  7 segment Display Table 
static bank1  unsigned char DISPTABLE[22]={0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F,0x73,
								   			//0  //1  //2  //3  //4  //5  //6  //7  //8  //9  //p
									    	0x50,0x71,0x76,0x40,0x00,0x79,0x78,0x77,0x39,0x3E,0x38};
									    	//r   f    h    -  blank  e    t    A    C     U   L 
// Bank1 Variables
static bank1 signed int Temp1=0;
//static bank1 unsigned char SETTEMPMSH=0,SETTEMPMSB=0,// Variables holding Set Value individual 
//						   SETTEMPMID=0,SETTEMPLSB=0;  // Digits.
unsigned char Digits[4]=0;		
static bank1 unsigned int  Set_Value=0;				   // Holds Set value for controlling.
static bank1 unsigned char HysVal = 0;				   // Holds hysterisis value for controlling
static bank1 unsigned char HYSMSB=0,HYSLSB=0;		   // Holds Hysterisis display digits
static bank1 unsigned char CONTROLREG=0;			   // Register holding status of display drivers	
static bank1 unsigned char BLINKSEGMENT=0;			   // Holds current blink position	
static bank1 unsigned char BLINKCOUNT=0;			   // Defines blink delay
static bank1 unsigned char BLINKFLAG=0;				   // Holds status whether to blink / not	 
static bank1 unsigned char CONFIG_PGM_MODE=0;
//static bank1 unsigned char SELECTPRESS=0;
static bank1 unsigned char Minus=0;					   // Flag deciding Minus sign on display 	
static bank1 unsigned char Crosd50Per=0,I_BandStarts=0;// Checks used identify whether controller 
static bank1 unsigned int Tint=0,TintCntr=0;		   // Integral brand relay on time counter.	
static bank1 unsigned int Tprop=0;					   // Proportional band relay on time counter
static bank1 unsigned int Counter=0;				   // Counter processing relay on time 	
static bank1 unsigned int MaxOverShoot=0;			   // Variable keeping track of Maximum	
static bank1 unsigned int ExtraTime=0;				   // if Temp. is falling / remains in same 	
static bank1 unsigned int PVBfr20Sec=0;  			   // Temp.Before 20sec is kept as backup
static bank1 unsigned int Rate=0;					   // Counter Monitors 20 sec period									
static bank1 unsigned int MaxShoot=0;				   // Keeps Maximum	overshoot after SV
static bank1 unsigned int Divide=0;					   // Keeps division factor in integral band.	
static bank1 unsigned int Prev_Valid=0;			   // Holds previously validated temperature.	
static bank1 unsigned int Valid_Deg=0;			   // Validated value after validation.	
static bank1 unsigned int ProDegrs=0;
static bank1 unsigned int Prev_Degree=0; 
static bank1 unsigned int ProDegrs2=0;
static bank1 int PV=0, SV=0;

unsigned int mSecCounter=0;	
unsigned char DgtSel=0;								   //DIGIT SELECT
unsigned char LEDBuffer[8]=0;
unsigned char ADCValue[2]=0;
unsigned int ADCResult=0;
unsigned int ADCdisplay=0;
unsigned char Count=0;
unsigned long ADCaverage=0;	
unsigned char svreached=0;		   
static bit RelayOn = 0,SV_Displaying=0;									   // Flag keeps track relay on/off status
static bit Valid=0;	
static bit HYS = 0;
static bit Hys_Mode = 0;
static bit CAL_Mode = 0,Minus_Offset=0,Run_Mode_Inc=0,SV_Display=0,MinusSV=0;
unsigned char  Diff = 0,TensCounter=0; 	 	
unsigned char  Perc=0,Ambient_Offset=5,INC_DEC_Cntr=0;	// Percentage calculation in PT100 readings;										   // Percentage calculation in PT100 readings
unsigned int Cntr_After_Pgm_SV = 0,Pgm_Mode_Enable=0;	


unsigned char PgmMode_Cntr=0,PgmMode_ExitCntr=0,MinusLimit_U=0,MinusLimit_L=0;
signed int Sensor_Range_U=0;
signed int Sensor_Range_L=0;
char J_Offset=0,K_Offset=0,PT100_Offset=0,Upper_limit=0;






void ShiftData(unsigned char Data)
{
        unsigned char i;

        OUTEN = 0;
        STROBE = 0;
        DISPCLK = 0;
        DISPDATA = 0;
	
        for(i = 0;i < 8;i++)
            {
                if(Data & 0x01) DISPDATA = 1;
                else DISPDATA = 0;

                DISPCLK = 1;	
                NOP(); 
                NOP(); 
                DISPCLK = 0;
                Data = Data >> 1;
		}
        STROBE = 1;
        NOP(); 
        NOP(); 
        STROBE = 0;
        OUTEN = 1;
}









void Display()									
   {
  	 switch(DgtSel)
		{
		case 0:
			LEDSEL = 0;
			ShiftData(0x10);
			PORTB = LEDBuffer[0];
			
			DgtSel = 1;
			break;

		case 1:
			ShiftData(0x20);
			PORTB = LEDBuffer[1];
		
			DgtSel = 2;
			break;

		case 2:
			ShiftData(0x40);
			PORTB = LEDBuffer[2];
		
			DgtSel = 3;
			break;

		case 3:
			ShiftData(0x80);
			PORTB = LEDBuffer[3];
			DgtSel = 4;
			break;

		case 4:
			OUTEN = 0;
			PORTB = CONTROLREG;
			LEDSEL = 1;
			DgtSel = 0;
			break;
		}
	 
	 
	 if(BLINKFLAG == 1 && DgtSel == BLINKSEGMENT)	// Check for blink status.If Digit to be
       { 											// blinked. Set the freq. to be blinked.
		  BLINKCOUNT++;
          if(BLINKCOUNT>20)
        	{ 
              PORTB  = DISPTABLE[15];
			  BLINKCOUNT++;
              if(BLINKCOUNT==40) BLINKCOUNT = 0;
            } 
	   }
	
	}													// End of display program





void CountsToDegree()	      
{

  		  ADCdisplay = ((ADCdisplay)/0.531);  				

		  ProDegrs   = ( (ADCdisplay - 90) - (K_Offset *  10 ) );
		 
	   	  if (ProDegrs <=1200)								
		  ProDegrs = (int)(ProDegrs*1.01);
		
		  else if	((ProDegrs >1200)&&(ProDegrs <=2400))	
		  ProDegrs = (int)(1200+(ProDegrs-1180)*1.03);
				   	
		  else if	((ProDegrs >2400)&&(ProDegrs <=3600))  
		  ProDegrs = (int)(2400+(ProDegrs-2340));
				    
		  else if	((ProDegrs >3600)&&(ProDegrs <=4800))  
		  ProDegrs = (int)(3600+(ProDegrs-3540)*0.985);
			   
		  else if	((ProDegrs >4800)&&(ProDegrs <=6000))  
		  ProDegrs = (int)(4800+(ProDegrs-4750)*0.975);
				    
		  else if	((ProDegrs >6000)&&(ProDegrs <=7200))  
		  ProDegrs = (int)(6000+(ProDegrs-5990)*0.986);
				    
		  else if	((ProDegrs >7200)&&(ProDegrs <=8400))  
		  ProDegrs = (int)(7200+(ProDegrs-7200)*1.01);
				    
		  else if	((ProDegrs >8400)&&(ProDegrs <=9600))  
		  ProDegrs = (int)(8400+(ProDegrs-8390)*1.04);
				    
		  else if	((ProDegrs >9600)&&(ProDegrs <=10800))  
		  ProDegrs = (int)(9600+(ProDegrs-9540)*1.07);
				    
		  else if	((ProDegrs >10800)&&(ProDegrs <=13000))  
		  ProDegrs = (int)(10800+(ProDegrs-10660)*1.11);
				    
		  ProDegrs2=ProDegrs; 
    	  ProDegrs= ( ProDegrs2 / 10);

		   if((ProDegrs>=0)&&(ProDegrs<=360))
			  ProDegrs = ProDegrs - 2 ;
	
		   if((ProDegrs>720)&&(ProDegrs<=960))
			  ProDegrs = ProDegrs -1 ;
	
		   if((ProDegrs>960)&&(ProDegrs<=1080))
			  ProDegrs = ProDegrs - 3 ;	
	
		   if((ProDegrs>1080)&&(ProDegrs<=1300))
			  ProDegrs = ProDegrs - 2 ;	


		   ProDegrs2=ProDegrs; 
    	   ProDegrs=ProDegrs2 - 2;	
 

     }
 


void IdleI2C1( void ) 
{
     unsigned int I2c_timeout;
	while ( ( SSP1CON2 & 0x1F ) | ( SSP1STATbits.R_W ) )
    {
       I2c_timeout++;
       if(I2c_timeout>4000)
       {
           I2c_timeout=0;
           return;
       }
        
    } 
        
	
}
 

 void RestartI2C1( void )
{
     IdleI2C1();
  SSP1CON2bits.RSEN = 1;           // initiate bus restart condition
}
 
 
 
 void StartI2C1( void )
{
     IdleI2C1();
  SSP1CON2bits.SEN = 1;            // initiate bus start condition
}
 
 
 void StopI2C1( void )
{
      IdleI2C1();
  SSP1CON2bits.PEN = 1;            // initiate bus stop condition
}
 
 
 void CloseI2C1( void )
{
      IdleI2C1();
  SSP1CON1 &= 0xDF;                // disable synchronous serial port
}
 
 void AckI2C1( void )
{
      IdleI2C1();
  SSP1CON2bits.ACKDT = 0;            // set acknowledge bit state for ACK
  SSP1CON2bits.ACKEN = 1;           // initiate bus acknowledge sequence
}

 
 void NotAckI2C1( void )
{
      IdleI2C1();
  SSP1CON2bits.ACKDT = 1;          // set acknowledge bit for not ACK
  SSP1CON2bits.ACKEN = 1;          // initiate bus acknowledge sequence
}


 unsigned char ReadI2C1( void )
{

if( ((SSP1CON1&0x0F)==0x08) || ((SSP1CON1&0x0F)==0x0B) )	//master mode only
  SSP1CON2bits.RCEN = 1;           // enable master for 1 byte reception
  while ( 1==SSP1STATbits.BF );      // wait until byte received  
    return ( SSP1BUF );              // return with read byte 
}



//**************************************************************************************************
void Dissect(unsigned long Value)		// Spliting of process value in digits form
 {
	unsigned char a,Temp;
	for(a = 0;a < 4; a++)
	 {
	  
	  Temp = Value%10;
	  Value = Value/10;
	  Digits[a]    = Temp; 
	  LEDBuffer[a] = DISPTABLE[Temp];	
       
	  
	 }
  
    
 }



void i2c_waitForIdle( void ) 
{
     unsigned int I2c_timeout;
	while ( ( SSP1CON2 & 0x1F ) | ( SSP1STATbits.R_W ) )
    {
       I2c_timeout++;
       if(I2c_timeout>4000)
       {
           I2c_timeout=0;
           return;
       }
      
    } 
        
	
}


unsigned char WriteI2C1( unsigned char i2cWriteData )
	{
	i2c_waitForIdle();
 	SSP1BUF = i2cWriteData;
 	return (0==SSP1CON2bits.ACKEN); 						// function returns '1' 
 											//if transmission is acknowledged
	}





void ReadADC()
	{
	unsigned int TimeOut;	  	
StartI2C1();
	while(!WriteI2C1(0XD0))
		{
		TimeOut++;
		if(TimeOut > 5000)
			{
			TimeOut = 0;
			return;
			}
		}
	
	if((CONTROLREG & 0x04) == 0x04)						
	WriteI2C1(0x89);					// gain 2
	else
	WriteI2C1(0x8B);
										//iniate the adc conversion one shot 18bit 
	RestartI2C1();					//8B for gain 8
	WriteI2C1(MCP3421ADDR+1); 			//8A for gain 4
	ADCValue[0] = i2c_read(1); 
	ADCValue[1] = i2c_read(0); 
	ADCResult = ADCValue[0];
	ADCResult = (ADCResult << 8) | ADCValue[1];
	ADCaverage += ADCResult;
	StopI2C1();
	}











//===========================================================================================
//   adc calculations
//===========================================================================================



void Read_MCP3425()
{
   SSP1CON2bits.RSEN =1;
 while(1==SSP1CON2bits.RSEN); 
 i2c_waitForIdle();  
 SSP1BUF =0b1101000;
 i2c_waitForIdle();  
 SSP1BUF =0X89;
 SSP1CON2bits.RSEN =1;
 while(1==SSP1CON2bits.RSEN);
 i2c_waitForIdle();  
 SSP1BUF =0b1101001;
 i2c_waitForIdle(); 
 SSP1CON2bits.RCEN =1;
while(1==SSP1CON2bits.RCEN);
 while (1==SSP1STATbits.BF); 
 ADCValue[0]=SSP1BUF;
 i2c_waitForIdle(); 
 
  while (1==SSP1STATbits.BF); 
 ADCValue[1]=SSP1BUF;

 ADCResult = (ADCResult << 8) | ADCValue[1];
	ADCaverage += ADCResult;
    
 IdleI2C1();
SSP1CON2bits.ACKDT = 1;      // Prepare to send NACK            
SSP1CON2bits.ACKEN = 1;      // Initiate NACK to EEPROM
 SSP1CON2bits.PEN=1;
while(1== SSP1CON2bits.PEN);
 
 
 
    
}


 void Average()
   { 
	 static unsigned char k;   
	 for(k=0;k<15;k++)
	 {
	 __delay_ms(25);
	 
    Read_MCP3425();
	 }
	 ADCdisplay = (ADCaverage / 15);
	 ADCaverage = 0;
   }   




void ISR_ROutine()
{
    
   if(PIR0bits.TMR0IF == 1)
   { 
       PIR0bits.TMR0IF =0;
       count=count+1;
       if(count>=30)
       {
        // Dissect(ADCaverage);
           Display();          
                           
       }
       
   }
    
}






void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();

    // If using interrupts in PIC18 High/Low Priority Mode you need to enable the Global High and Low Interrupts
    // If using interrupts in PIC Mid-Range Compatibility Mode you need to enable the Global and Peripheral Interrupts
    // Use the following macros to:

    // Enable high priority global interrupts
    //INTERRUPT_GlobalInterruptHighEnable();

    // Enable low priority global interrupts.
    //INTERRUPT_GlobalInterruptLowEnable();

    // Disable high priority global interrupts
    //INTERRUPT_GlobalInterruptHighDisable();

    // Disable low priority global interrupts.
    //INTERRUPT_GlobalInterruptLowDisable();

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    while (1)
    {
        Average();
        CountsToDegree();
      	Dissect(ProDegrs);
        __delay_ms(100);
        
        //Read_MCP3425();
    }
}